// MetalRomRen_to_CatShanty.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include "MetalRomRen_to_CatShanty.h"


//G[l̒`
const int ERR_ListFileNotFound	= 0x100;	//256	Xgt@CJȂ
const int ERR_CRCNotFound		= 0x200;	//512	Xgt@CɎw肳ꂽCRCl
const int ERR_ListNA			= 0x201;	//513	płȂXgۂ
const int ERR_ValAbsence		= 0x300;	//768	擾Yf[^͕s݂
const int ERR_ValNoNumeric		= 0x301;	//769	擾lł͂Ȃi߂ll̗̂pj

/********************************************************
g~O
http://www.cplusplus.com/faq/sequences/strings/trim/
********************************************************/
inline std::string trim_right_copy( const std::string& s, const std::string& delimiters = " \f\n\r\t\v" ){
  return s.substr( 0, s.find_last_not_of( delimiters ) + 1 );
}
inline std::string trim_left_copy( const std::string& s, const std::string& delimiters = " \f\n\r\t\v" ){
  return s.substr( s.find_first_not_of( delimiters ) );
}
inline std::string trim_copy( const std::string& s, const std::string& delimiters = " \f\n\r\t\v" ){
  return trim_left_copy( trim_right_copy( s, delimiters ), delimiters );
}

/*************************************************************************************************************

MetalRomRen f[^L[āAړI̕擾Ei[

	pData		Xgf[^̃|C^
	pKEY		L[̃|C^
	iKEYbit		L[̌`ԁi 0,32=32bitCRC / 1=16bitCRC / 100=FileName(body) / 101=FileName(body.ext) j
	pBuf		i[̃|C^
	iSize		i[obt@̃TCY
				0 ͕Kvȃobt@TCYԂis܂ށj
	itemPos		MetalRomRen*.dat ɂāA擾񂪊YC̐擪牽ڂ̃J}(,)̌ɂ邩

	* MetalRomRen*.dat 1C̉sR[hI[ \n O

*************************************************************************************************************/
int GetText( LPCTSTR &pData, LPCTSTR &pKEY, int iKEYbit, LPSTR &pBuf, int iSize, int itemPos )
{
	//MetalRomRen*.dat  CRC 
	if( iKEYbit > 32 ) return ERR_CRCNotFound * -1;

	using namespace std;
	string dat  = (LPCSTR) pData;
	string datU = (LPCSTR) pData;
	string key  = (LPCSTR) pKEY;
	string key2 = (LPCSTR) pKEY;
	string::size_type idx;
	string::size_type edx;

	//pɑ啶
	transform( datU.begin(), datU.end(), datU.begin(), toupper );
	transform( key.begin(),  key.end(),  key.begin(),  toupper );
	transform( key2.begin(), key2.end(), key2.begin(), toupper );

	//L[̐`
	switch (iKEYbit){
	case 0:
	case 32:
		while( key.length() < 8 ) key = "0" + key;
		break;
	case 1:
		while( key.length() < 4 ) key = "0" + key;
		break;
	}
	key = ","+ key  +",";	// ex) ",00123ABC," = 1,194,684
	key = ","+ key2 +",";	// ex) ",123ABC,"   = 1,194,684

	//f[^L[
	idx = datU.find( key );
	if( idx == string::npos ) idx = datU.find( key2 );

	//ړI̕擾
	if( idx == string::npos ){
		return ERR_CRCNotFound * -1;	//sȂG[
	}else{
		//|WVYC̐擪
		idx = datU.rfind( "\n", idx );
		//ACe擪
		for(int i=0; i<itemPos; i++){
			idx = dat.find( ",", idx );
			if( idx == string::npos ) return ERR_ValAbsence * -1;
			idx ++;
		}
		//ACeI[
		edx = dat.find( ",", idx );
		if( idx == string::npos ) return ERR_ValAbsence * -1;
	}

	//߂lƊi[
	if( iSize == 0 ){
		return edx - idx + 1;	//Kvobt@Ԃ
	} else {
		int size = edx - idx;
		if( iSize < size + 1 ) size = iSize - 1;							//wTCYȂJbg
		strcpy_s( pBuf, iSize, (LPSTR)dat.substr( idx, size ).c_str() );	//i[
		return size;
	}
}



//////////////////////////////////////////////////////////////////////

// ȉGNX|[g֐ł

//////////////////////////////////////////////////////////////////////


//---- vOCn --------------------------------------------------------------------------


//vOCo[WԂ
METALROMREN_TO_CATSHANTY_API int GetPluginVersion()
{
	return (int) (2.00 * 100);
}

//vOCҏi[
METALROMREN_TO_CATSHANTY_API int GetPluginAuthor( LPSTR &lpszAuthor, int iSize )
{
	std::string str = "hey_kitarou - www.catshanty.com";	//Jl̏ɕς邱
	if( iSize == 0 ){
		return str.length() + 1;					//TCYԂ
	} else {
		if( int(str.length()+1) > iSize ) str = str.substr( 0, iSize-1 );	//wobt@TCYȂJbg
		strcpy_s( lpszAuthor, iSize, str.c_str() );	//i[
		return str.length();
	}
}

//vOC̐i[
METALROMREN_TO_CATSHANTY_API int GetPluginInfo( LPSTR &lpszInfo, int iSize )
{
	std::string str = "Maki@HarmonicMinor  MetalRomRen pl[f[^q؂܂B";
	if(iSize==0){
		return str.length() + 1;
	} else {
		if( int(str.length()+1) > iSize ) str = str.substr( 0, iSize-1 );
		strcpy_s( lpszInfo, iSize, str.c_str() );
		return str.length();
	}
}


//---- i[n --------------------------------------------------------------------------

//^Cgi[
METALROMREN_TO_CATSHANTY_API int GetTitle( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit, LPSTR &pBuf, int iSize )
{
	return GetText( pData, pKEY, iKEYbit, pBuf, iSize, 1 );
}

//[J[i[
METALROMREN_TO_CATSHANTY_API int GetMaker( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit, LPSTR &pBuf, int iSize )
{
	return GetText( pData, pKEY, iKEYbit, pBuf, iSize, 2 );
}

//i[
METALROMREN_TO_CATSHANTY_API int GetCountry( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit, LPSTR &pBuf, int iSize )
{
	return GetText( pData, pKEY, iKEYbit, pBuf, iSize, 14 );
}

//o[Wi[
METALROMREN_TO_CATSHANTY_API int GetVersion( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit, LPSTR &pBuf, int iSize )
{
	return GetText( pData, pKEY, iKEYbit, pBuf, iSize, 6 );
}

//Ni[
METALROMREN_TO_CATSHANTY_API int GetYear( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit )
{
	int res;
	int yr = -1;

	LPSTR pTmp = (LPSTR)calloc( 256, sizeof(int) );
	res = GetText( pData, pKEY, iKEYbit, pTmp, 255, 13 );
	if( strlen(pTmp) > 0 ) yr = atoi( pTmp );
	free( pTmp );

	if( res < 0 ) return res;

	if( yr == -1 ) return ERR_ValAbsence * -1;
	if( yr < 1850 || yr > 2060 ) return ERR_ValNoNumeric * -1;

	return yr;
}


